/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020, 2021                              ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#ifndef DRN_ACCOUNTING_INTERNAL_ACCOUNTBALANCEKEY_HPP_
#define DRN_ACCOUNTING_INTERNAL_ACCOUNTBALANCEKEY_HPP_


namespace drn
{
namespace accounting
{
namespace tests
{

struct AccountUT;
struct GeneralLedgerUT;
struct TransactionUT;

}
namespace internal
{

struct TransactionPoster;

/**
 * @brief Provides the means to grant access to changing an account's balance and its transactions.
 */
class AccountTransactionKey final
{
	friend struct tests::AccountUT;
	friend struct tests::GeneralLedgerUT;
	friend struct tests::TransactionUT;
	friend struct TransactionPoster;

	AccountTransactionKey();
	AccountTransactionKey(const AccountTransactionKey&) = delete;
	AccountTransactionKey(AccountTransactionKey&&) = delete;
	AccountTransactionKey& operator=(const AccountTransactionKey&) = delete;
	AccountTransactionKey& operator=(AccountTransactionKey&&) = delete;
};

}}}

inline drn::accounting::internal::AccountTransactionKey::AccountTransactionKey()
{}

#endif
