/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020, 2021                              ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#include "BankAccount.h"
using drn::banking::BankAccount;

#include <ostream>
using std::ostream;
#include <tuple>
using std::tie;


bool drn::banking::operator<(const BankAccount& lhs, const BankAccount& rhs)
{
	return tie(lhs.bank_, lhs.account_) < tie(rhs.bank_, rhs.account_);
}

bool drn::banking::operator==(const BankAccount& lhs, const BankAccount& rhs)
{
	return tie(lhs.bank_, lhs.account_) == tie(rhs.bank_, rhs.account_);
}

bool drn::banking::operator!=(const BankAccount& lhs, const BankAccount& rhs)
{
	return ! (lhs == rhs);
}

ostream& drn::banking::operator<<(ostream& out, const BankAccount& ba)
{
	return out << "Bank (" << ba.bank_ << "), Account (" << ba.account_ << ')';
}
