/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020, 2021                              ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#include "BankingErrors.h"
using std::exception;
using drn::banking::BankError;
using drn::foundation::Error;

#include <QObject>
using ::QObject;
#include <QString>
using ::QString;

#include <utility>
using std::move;

#include "BankName.h"
using drn::banking::BankName;


BankError::BankError(const BankName& name, const QString& message, const exception& root) :
	Error{
		QObject::tr("The bank '%1' is invalid. %2").arg(name.institution()).arg(message),
		root
	}
{}

