/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020, 2021                              ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#include "BudgetItemIdentifier.h"
using drn::budgeting::BudgetItemIdentifier;
using drn::budgeting::presentationText;

#include <ostream>
using std::ostream;
#include <tuple>
using std::tie;


bool drn::budgeting::operator<(const BudgetItemIdentifier& lhs, const BudgetItemIdentifier& rhs)
{
	return tie(lhs.type_, lhs.source_) < tie(rhs.type_, rhs.source_);
}

bool drn::budgeting::operator==(const BudgetItemIdentifier& lhs, const BudgetItemIdentifier& rhs)
{
	return tie(lhs.type_, lhs.source_) == tie(rhs.type_, rhs.source_);
}

bool drn::budgeting::operator!=(const BudgetItemIdentifier& lhs, const BudgetItemIdentifier& rhs)
{
	return ! (lhs == rhs);
}

ostream& drn::budgeting::operator<<(ostream& o, const BudgetItemIdentifier& bii)
{
	return o << "Type (" << bii.type_ << ") Source (" << bii.source_ << ')';
}

QString drn::budgeting::presentationText(const BudgetItemIdentifier& bii)
{
	return QString{"%1 (%2)"}.arg(bii.source_.name()).arg(presentationText(bii.type_));
}
