/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020, 2021                              ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#include "BudgetingErrors.h"
using ::QString;
using std::exception;
using drn::foundation::Error;
using drn::budgeting::BudgetItemError;

#include <QObject>
using ::QObject;

#include "BudgetSource.h"
using drn::budgeting::BudgetSource;


BudgetItemError::BudgetItemError(const BudgetSource& bs, const QString& message) :
	Error{
		QObject::tr("There is an issue with the budget item '%1'. %2").arg(bs.name()).arg(message)
	}
{}

BudgetItemError::BudgetItemError(
	const BudgetSource& bs,
	const QString& message,
	const exception& root
) :
	Error{
		QObject::tr("There is an issue with the budget item '%1'. %2").arg(bs.name()).arg(message),
		root
	}
{}
