/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020, 2021                              ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#ifndef DRN_DESKTOP_UI_INTERNAL_BUDGETHEALTHWIDGET_H
#define DRN_DESKTOP_UI_INTERNAL_BUDGETHEALTHWIDGET_H

#include <QWidget>

#include <ui_BudgetHealthWidget.h>


namespace drn
{
namespace adviser
{

class BudgetHealth;

}
namespace budgeting
{

enum class BudgetItemTypes : quint8;

}
namespace foundation
{

template<typename>
class ObserverPtr;

}
namespace desktop_ui
{
namespace internal
{

class BudgetHealthWidget : public QWidget, Ui::BudgetHealthWdgt
{
	Q_OBJECT

signals:
	void displayBudgetInterface(const budgeting::BudgetItemTypes& type);

public:
	explicit BudgetHealthWidget(const foundation::ObserverPtr<::QWidget>& parent);
	void updateTotals(
		const budgeting::BudgetTotals& bt,
		const pecunia::currency::Iso4217Codes& preferred
	);
	void updateHealth(const adviser::BudgetHealth& bh);
};

}}}

#endif
