/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020, 2021                              ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#ifndef DRN_DESKTOP_UI_INTERNAL_BUDGETITEMSDUEWIDGET_H_
#define DRN_DESKTOP_UI_INTERNAL_BUDGETITEMSDUEWIDGET_H_

#include <QWidget>

#include <vector>

#include <foundation/CalendarTime.hpp>
#include <ui_BudgetItemsDueWidget.h>


class QResizeEvent;

namespace drn
{
namespace budgeting
{

struct BudgetItemDue;

}
namespace foundation
{

template<typename>
class ObserverPtr;

}
namespace desktop_ui
{
namespace internal
{

class BudgetItemsDueWidget : public QWidget, Ui::BudgetItemsDueWdgt
{
	Q_OBJECT

protected:
	void resizeEvent(QResizeEvent* event) override;

public:
	BudgetItemsDueWidget(const foundation::ObserverPtr<::QWidget>& parent);
	void updateDue(
		const std::vector<budgeting::BudgetItemDue>& itemsDue,
		const foundation::Days& within
	);
};

}}}

#endif
