/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020, 2021                              ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#include "Error.h"
using ::QString;
using std::exception;
using std::runtime_error;
using drn::foundation::Error;

#include <QObject>
using ::QObject;


namespace
{

const QString defaultExecptionMessage{
#	ifndef _MSC_VER
		"std::exception"
#	else
		"Unknown exception"
#	endif
};

}

Error::Error(const QString& message, const exception& root) :
	runtime_error{
		(
			message + (
				defaultExecptionMessage == root.what()
					? QString{}
					: QObject::tr(" Caused By: %1").arg(root.what())
			)
		).toStdString()
	},
	message_{message}
{}

const QString& Error::message() const
{
	return this->message_;
}
