/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020, 2021                              ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#include "PresentationText.h"

#include <pecunia/Codes.h>
using pecunia::currency::Iso4217Codes;
using pecunia::currency::minorUnitDigits;
using pecunia::currency::toStdString;
#include <pecunia/Money.h>
using pecunia::currency::Money;
#include <pecunia/MoneySize.hpp>
using pecunia::precision;
#include <QLocale>
using ::QLocale;
#include <QString>
using ::QString;


QString drn::foundation::presentationText(const Iso4217Codes& code)
{
	return QString::fromStdString(toStdString(code));
}

QString drn::foundation::presentationText(const Money& money)
{
	const auto major{QString::number(money.major())};
	const auto minor{QString::number(money.minor())};
	const QLocale locale{};
	return QString{"%1%2%3"}.arg(major)
		.arg(locale.decimalPoint())
		.arg(minor, minorUnitDigits(money.code()) + precision, '0');
}
