/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020, 2021                              ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#include "NetworkErrors.h"
using std::exception;
using drn::network::ReplyError;
using drn::foundation::Error;

#include <QNetworkReply>
using ::QNetworkReply;
#include <QObject>
using ::QObject;
#include <QString>
using ::QString;


ReplyError::ReplyError(
	const QNetworkReply& reply,
	const QString& details,
	const exception& root
) :
	Error{
		QObject::tr("The reply for, %1 , had an error. %2. %3")
			.arg(reply.request().url().toString())
			.arg(reply.errorString())
			.arg(details),
		root
	}
{}

